﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий дисципилну кафедры
	/// </summary>
	[DataContract]
	[EntityDescription("Discipline", "Дисципилна кафедры")]
	[EntityDependency("DisciplineBlock", "EmployeeId", "Сотрудник, отвечающий за аудиторию")]
	public class Discipline : BaseEntity, IEntitySecurityExtenstion<Discipline>
    {
        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("DisciplineBlockId")]
        public Guid DisciplineBlockId { get; set; }

        [DataMember]
        [Required(ErrorMessage = "required")]
        [MapConfiguration("DisciplineName")]
        public string DisciplineName { get; set; }

        [DataMember]
        [MapConfiguration("DisciplineShortName")]
        public string DisciplineShortName { get; set; }

        [MapConfiguration("DisciplineBlueAsteriskName")]
        public string DisciplineBlueAsteriskName { get; set; }

		//-------------------------------------------------------------------------

		public virtual DisciplineBlock DisciplineBlock { get; set; }

        //-------------------------------------------------------------------------

        //-------------------------------------------------------------------------

        public Discipline SecurityCheck(Discipline entity, bool allowFullData) => entity;
	}
}